version = ('5.61', 'release')

from .cvisual import (vector, dot, mag, mag2, norm, cross, rotate,
                       comp, proj, diff_angle, rate, waitclose)
from .primitives import (arrow, cylinder, cone, sphere, box, ring, label,
                               frame, pyramid, ellipsoid, curve, faces, convex, helix,
                               points, text, distant_light, local_light, extrusion)
try:
    from Polygon import Polygon
except:
    pass

from .ui import display
scene = display() # a display needs to exist in order for an object reference to work
from . import crayola
color = crayola
from . import materials
from . import site_settings # need to study this

# Allow cvisual itself to load files from the vis package - used by GTK
#   driver to load glade data files
import os.path as _os_path
from .cvisual import _set_dataroot
_set_dataroot( _os_path.split( __file__ )[0] + _os_path.sep)

